
// Constants

const DBTAG = 'DualBlock: ';
// In about:config a new string value "extensions.sdk.console.logLevel" must be set to "all"
// and browser console must be in multiprocess mode

const PREF_BLOCK_IMAGES          = 'blockImages';
const DEFAULT_BLOCK_IMAGES       = false;

const PREF_LOG_INTERVENTIONS     = 'logInterventions';
const DEFAULT_LOG_INTERVENTIONS  = false;


const PREF_LIST_LOCATIONS        = 'listLocations';
const DEFAULT_LIST_LOCATIONS     = [ ];

const PREF_LIST_IMAGES           = 'listImages';
const DEFAULT_LIST_IMAGES        = [ ];

const PREF_LIST_CONTENTS         = 'listContents';
const DEFAULT_LIST_CONTENTS      = [ ];

const PREF_LIST_NAVIGATIONS      = 'listNavigations';
const DEFAULT_LIST_NAVIGATIONS   = [ ];

const PREF_LIST_HEADERS          = 'listHeaders';
const DEFAULT_LIST_HEADERS       = [ ];

const FILE_LIST_LOCATIONS = 'dualblock_urls.txt';
const FILE_LIST_IMAGES = 'dualblock_images.txt';
const FILE_LIST_CONTENTS = 'dualblock_contents.txt';
const FILE_LIST_NAVIGATIONS = 'dualblock_aims.txt';
const FILE_LIST_HEADERS = 'dualblock_headers.txt';

const listDescriptors = [
  { title: 'Blocked Images',
    columns: [ 'url', 'referer' ], modifiers: [ 'i', 'i' ],
    file: FILE_LIST_IMAGES, settings: PREF_LIST_IMAGES },
  { title: 'Blocked Locations',
    columns: [ 'url', 'referer', 'target' ], modifiers: [ 'i', 'i', '$' ],
    file: FILE_LIST_LOCATIONS, settings: PREF_LIST_LOCATIONS },
  { title: 'Modified Contents',
    columns: [ 'url', 'match', 'subst' ], modifiers: [ 'i', 'm', '$' ],
    file: FILE_LIST_CONTENTS, settings: PREF_LIST_CONTENTS },
  { title: 'Blocked Navigations',
    columns: [ 'origin', 'aim', 'close' ], modifiers: [ 'i', 'i', 'i' ],
    file: FILE_LIST_NAVIGATIONS, settings: PREF_LIST_NAVIGATIONS },
  { title: 'Modified Headers',
    columns: [ 'url', 'header', 'match', 'subst' ], modifiers: [ 'i', '$', 'i', '$' ],
    file: FILE_LIST_HEADERS, settings: PREF_LIST_HEADERS }
];
